﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using WcfRestaurant.Procesos;


namespace WcfRestaurant.Dalc
{
    public class dalcClient
    {
        dalcLlibreriaBD objBD;

        ///<summary>
        ///Constructor de l'objecte que gestiona l'acces a dades.
        ///</summary>
        public dalcClient()
        {
            objBD = new dalcLlibreriaBD();
        }



        ///<summary>
        ///Obté un client en concret de la base de dades i informa les seves dades en un objecte client.
        ///</summary>
        ///<return>
        ///Rttorna un objecte client amb les dades del registre amb l'identificador solicitat.
        ///</return>
        ///<param name="IdTreballador">
        ///Cadena amb l'identificador de registre d'un client.
        ///</param>
        public ComuRestaurant.Objectes.Client Obtindre(string IdClient)
        {
            string strSQL = "";
            ComuRestaurant.Objectes.Client objClient = null;
            if (IdClient.Trim().Length > 0)
            {
                strSQL = "SELECT IdClient,Nom,Mail,Cognom1,Cognom2 FROM Clients WHERE IdClient = " + objBD.VtoSQL(IdClient);
                DataSet ds = objBD.GenerarSelect(strSQL);
                if (ds.Tables[0].Rows.Count > 0)
                {
                    objClient = new ComuRestaurant.Objectes.Client();
                    objClient.IdClient = Convert.ToInt32(ds.Tables[0].Rows[0]["IdClient"]);
                    objClient.Nom = ds.Tables[0].Rows[0]["Nom"].ToString();
                    objClient.Cognom1 = ds.Tables[0].Rows[0]["Cognom1"].ToString();
                    objClient.Cognom2 = ds.Tables[0].Rows[0]["Cognom2"].ToString();
                    objClient.Mail = ds.Tables[0].Rows[0]["Mail"].ToString();
                }
            }
            return objClient;
        }


        ///<summary>
        ///Elimina un client en concret de la base de dades.
        ///</summary>
        ///<return>
        ///retorna una cadena de texte informant dels errors esdevenits. Si la cadena esta vuida tot a funcionat correctament.
        ///</return>
        ///<param name="IdTreballador">
        ///Cadena amb l'identificador de registre d'un client.
        ///</param>
        public string Eliminar(string IdClient)
        {
            string strSQL = "DELETE FROM Clients WHERE IdClient=@IdClient";
            System.Data.SqlClient.SqlParameter[] sSqlParametros = new System.Data.SqlClient.SqlParameter[1];
            sSqlParametros[0] = objBD.CrearParametreSQL("@IdClient", IdClient, false);
            string strRet = objBD.ExecutarSentencia(strSQL, sSqlParametros);

            return strRet;
        }
        

        //<summary>
        ///Obté una llista dels clients que existeixen a la base de dades i informa les seves dades d'un objecte Client.
        ///</summary>
        ///<return>
        ///Retornat un objecte client que conte una llista d'objetes trebalador amb la informació dels clients.
        ///</return>
        public List<ComuRestaurant.Objectes.Client> ObtindreTots()
        {
            string strSQL = "";
            ComuRestaurant.Objectes.Client objClient = null;
            ComuRestaurant.Objectes.Clients colClient = new ComuRestaurant.Objectes.Clients();

            strSQL = "SELECT IdClient,Nom,Cognom1,Cognom2,Mail FROM Clients";
            DataSet ds = objBD.GenerarSelect(strSQL);
            for (int i = 0; i < ds.Tables[0].Rows.Count; i++)
            {
                objClient = new ComuRestaurant.Objectes.Client();
                objClient.IdClient = Convert.ToInt32(ds.Tables[0].Rows[i]["IdClient"]);
                objClient.Nom = ds.Tables[0].Rows[i]["Nom"].ToString();
                objClient.Cognom1 = ds.Tables[0].Rows[i]["Cognom1"].ToString();
                objClient.Cognom2 = ds.Tables[0].Rows[i]["Cognom2"].ToString();
                objClient.Mail = ds.Tables[0].Rows[i]["Mail"].ToString();


                colClient.addTreballador(objClient);
            }
            return colClient.getllista(); 
        }

        /// <summary>
        /// Obté el total de clients que hi ha la base de dades.
        /// </summary>
        /// <returns>
        /// Retorna un integeramb el  número total de clients que hi ha a la base de dades.
        /// </returns>
        public int TotalClients()
        {
            string strSQL = "SELECT Count(*) FROM Clients ";
            DataSet ds = objBD.GenerarSelect(strSQL);
            return ds.Tables[0].Rows.Count ;
        }
    }
}
