﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using WcfRestaurant.Procesos;


namespace WcfRestaurant.Dalc
{
    public class dalcComanda
    {
         dalcLlibreriaBD objBD;

        ///<summary>
        ///Constructor de l'objecte que gestiona l'acces a dades.
        ///</summary>
         public dalcComanda()
        {
            objBD = new dalcLlibreriaBD();
        }



        ///<summary>
        ///Obté una comanda en concret de la base de dades i informa les seves dades en un objecte Comanda.
        ///</summary>
        ///<return>
        ///Retorna un objecte Comanda amb les dades del registre amb l'identificador solicitat.
        ///</return>
         ///<param name="IdComanda">
        ///Cadena amb l'identificador de registre d'una comanda.
        ///</param>
        public ComuRestaurant.Objectes.Comanda Obtindre(string IdComanda)
        {
            string strSQL = "";
            ComuRestaurant.Objectes.Comanda objComanda = null;
            if (IdComanda.Trim().Length > 0)
            {
                strSQL = "SELECT IdComanda,Taula,Comensals FROM Comandes WHERE IdComanda = " + objBD.VtoSQL(IdComanda);
                DataSet ds = objBD.GenerarSelect(strSQL);
                if (ds.Tables[0].Rows.Count > 0)
                {
                    objComanda = new ComuRestaurant.Objectes.Comanda();
                    objComanda.IdComanda = Convert.ToInt32(ds.Tables[0].Rows[0]["IdComanda"]);
                    objComanda.Taula = Convert.ToInt32(ds.Tables[0].Rows[0]["Taula"].ToString());
                    objComanda.Comensals = Convert.ToInt32(ds.Tables[0].Rows[0]["Comensals"].ToString());
                    dalcLiniesComada dalcLinies =new dalcLiniesComada();
                    objComanda.LiniesComandes = dalcLinies.ObtindreLiniesPerComanda(IdComanda);
                }
            }
            return objComanda;
        }


        ///<summary>
        ///Elimina una comanda i les seves linies en concret de la base de dades.
        ///</summary>
        ///<return>
        ///retorna una cadena de texte informant dels errors esdevenits. Si la cadena esta vuida tot a funcionat correctament.
        ///</return>
        ///<param name="IdComanda">
        ///Cadena amb l'identificador de registre d'una comanda.
        ///</param>
        public string Eliminar(string IdComanda)
        {

            string strSQL = "DELETE FROM LiniesComanda WHERE IdComanda=@IdComanda";
            System.Data.SqlClient.SqlParameter[] sSqlParametros = new System.Data.SqlClient.SqlParameter[1];
            sSqlParametros[0] = objBD.CrearParametreSQL("@IdComanda", IdComanda, false);
            string strRet = objBD.ExecutarSentencia(strSQL, sSqlParametros);

            strSQL = "DELETE FROM Comandes WHERE IdComanda=@IdComanda";
            sSqlParametros = new System.Data.SqlClient.SqlParameter[1];
            sSqlParametros[0] = objBD.CrearParametreSQL("@IdComanda", IdComanda, false);
            strRet = objBD.ExecutarSentencia(strSQL, sSqlParametros);

            return strRet;
        }
        

        //<summary>
        ///Obté una llista de les comandes que existeixen a la base de dades i informa les seves dades d'un objecte Comanda.
        ///</summary>
        ///<return>
        ///Retornat un objecte comanda que conte una llista d'objetes comanda amb la informació de les camandes.
        ///</return>
        public List<ComuRestaurant.Objectes.Comanda> ObtindreTots()
        {
            string strSQL = "";
            ComuRestaurant.Objectes.Comanda objComanda = null;
            ComuRestaurant.Objectes.Comandes colComanda = new ComuRestaurant.Objectes.Comandes();

            strSQL = "SELECT IdComanda,Taula,Comensals FROM Comandes";
            DataSet ds = objBD.GenerarSelect(strSQL);
            for (int i = 0; i < ds.Tables[0].Rows.Count; i++)
            {
                objComanda = new ComuRestaurant.Objectes.Comanda();
                objComanda.IdComanda = Convert.ToInt32(ds.Tables[0].Rows[i]["IdComanda"]);
                objComanda.Taula = Convert.ToInt32(ds.Tables[0].Rows[i]["Taula"].ToString());
                objComanda.Comensals = Convert.ToInt32(ds.Tables[0].Rows[i]["Comensals"].ToString());
                dalcLiniesComada dalcLinies = new dalcLiniesComada();
                objComanda.LiniesComandes = dalcLinies.ObtindreLiniesPerComanda(ds.Tables[0].Rows[i]["IdComanda"].ToString());

                colComanda.addComanda(objComanda);
            }
            return colComanda.getllista(); 
        }

        /// <summary>
        /// Obté el total de Comandes que tenen línies pendents de servir a la base de dades.
        /// </summary>
        /// <returns>
        /// Retorna un integer amb el número total de comandes amb línies pendent que hi ha a la base de dades.
        /// </returns>
        public int TotalComandes()
        {
            string strSQL = "SELECT Count(C.IdComanda) As Total FROM Comandes C INNER JOIN LiniesComanda LC ON (LC.IdComanda=C.IdComanda) WHERE LC.Servida=0 GROUP BY C.IdComanda ORDER BY C.IdComanda";
            DataSet ds = objBD.GenerarSelect(strSQL);
            if (ds.Tables[0].Rows.Count > 0) {
            return Convert.ToInt32(ds.Tables[0].Rows[0]["Total"].ToString());}
            else{ return 0;}
        }


         ///<summary>
        ///Desa una comanda i les seves linies a la base de dades.
        ///</summary>
        ///<return>
        ///retorna una cadena de texte informant dels errors esdevenits. Si la cadena esta vuida tot a funcionat correctament.
        ///</return>
        ///<param name="Comanda">
        ///Comanda i linies de la comanda
        ///</param>
        public string DesarComanda(string Comanda)
        {
            string sComensals = "", sIdComanda = "", sTaula = "",strRet = "",sLineaComanda = "";
            string sIdPlat1="", sIdPlat2="", sIdPostres="";
            string[] sComanda, sLinea;               
            char caracter = Convert.ToChar("-");
            sComanda = Comanda.Split(caracter);

            sTaula = sComanda[0];
            sComensals = sComanda[1];

            //Desar Comanda

            string strSQL = "";

            System.Data.SqlClient.SqlParameter[] sSqlParametros = new System.Data.SqlClient.SqlParameter[2];
            sSqlParametros[0] = objBD.CrearParametreSQL("@Taula", sTaula, true);
            sSqlParametros[1] = objBD.CrearParametreSQL("@Comensals", sComensals, true);
            strSQL = "INSERT INTO Comandes (Taula,Comensals) VALUES (@Taula,@Comensals)";
            strRet = objBD.ExecutarSentencia(strSQL, sSqlParametros);

            if (strRet == "")
            { 
            
                strSQL = "SELECT Max(IdComanda) AS IdComanda FROM Comandes WHERE Taula = "+ objBD.VtoSQL(sTaula)+" AND Comensals=" + objBD.VtoSQL(sComensals);
                DataSet ds = objBD.GenerarSelect(strSQL);
                if (ds.Tables[0].Rows.Count > 0)
                {
                    sIdComanda = ds.Tables[0].Rows[0]["IdComanda"].ToString();
                    caracter = Convert.ToChar("#");
                    dalcLiniesComada dalcLinea = new dalcLiniesComada();
                    
                    for (int i = 2; i < sComanda.Length; i++)
                    {
                        sLineaComanda = sComanda[i].ToString();
                        sLinea = sLineaComanda.Split(caracter);

                        sIdPlat1 = sLinea[0];
                        sIdPlat2 = sLinea[2];
                        sIdPostres = sLinea[4];

                        strRet = dalcLinea.DesarLineaComanda(sIdComanda, sIdPlat1, sIdPlat2, sIdPostres);
                        if (strRet != "") { return strRet; }
                    }
                }
                else
                {
                    strRet="Error al obtenir l'identificador de la comanda";
                }
            }
            
            return strRet;
  
        } 
    }
}
