﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WcfRestaurant.Objectes
{
    public class Comanda
    {
        private int idComanda;
        private int taula;
        private int comensals;
        private ICollection<LineaComanda> liniesComandes;



        public int IdComanda
        {
            get { return this.idComanda; }
            set { this.idComanda = value; }
        }

        public int Taula
        {
            get { return this.taula; }
            set { this.taula = value; }
        }

        public int Comensals
        {
            get { return this.comensals; }
            set { this.comensals = value; }
        }

        public ICollection<LineaComanda> LiniesComandes
        {
            get { return this.liniesComandes; }
            set { this.liniesComandes = value; }
        }


    }

    public class Comandes
    {
        private Dictionary<int, Comanda> colComandes;

        public Comandes()
        {
            this.colComandes = new Dictionary<int, Comanda>();
        }

        public bool addComanda(Comanda objComanda)
        {
            if (Existe(objComanda.IdComanda))
            {
                return false;
            }
            else
            {
                colComandes.Add(objComanda.IdComanda, objComanda);
                return true;
            }
        }

        public bool delComanda(int idComanda)
        {
            if (Existe(idComanda))
            {
                return colComandes.Remove(idComanda);
            }
            else
            {
                return false;
            }
        }
        public bool delComanda(Comanda objComanda)
        {
            if (Existe(objComanda.IdComanda))
            {
                return colComandes.Remove(objComanda.IdComanda);
            }
            else
            {
                return false;
            }
        }

        public bool Existe(int idComanda)
        {
            if (colComandes.ContainsKey(idComanda))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        public Comanda getComanda(int idComanda)
        {
            if (Existe(idComanda))
            {
                return colComandes[idComanda];
            }
            else
            {
                return null;
            }
        }

        public Dictionary<int, Comanda> getDiccionario()
        {
            return colComandes;
        }
    }
}
