﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WcfRestaurant.Objectes
{
    public class LineaComanda
    {
        private int idLineaComanda;
        private Plat idPlat1;
        private Plat idPlat2;
        private Plat idPostre;
        private bool servida;
              
         public int IdLineaComanda
        {
            get { return this.idLineaComanda; }
            set { this.idLineaComanda = value; }
        }
        
        public Plat IdPlat1
        {
            get { return this.idPlat1; }
            set { this.idPlat1 = value; }
        }

        public Plat IdPlat2
        {
            get { return this.idPlat2; }
            set { this.idPlat2 = value; }
        }

        public Plat IdPostre
        {
            get { return this.idPostre; }
            set { this.idPostre = value; }
        }

        public bool Servida
        {
            get { return this.servida; }
            set { this.servida = value; }
        }

    }

    public class LiniesComanda
    {
        private Dictionary<int, LineaComanda> colLiniesComanda;

        public LiniesComanda()
        {
            this.colLiniesComanda = new Dictionary<int, LineaComanda>();
        }

        public bool addLineaComanda(LineaComanda objLineaComanda)
        {
            if (Existe(objLineaComanda.IdLineaComanda))
            {
                return false;
            }
            else
            {
                colLiniesComanda.Add(objLineaComanda.IdLineaComanda, objLineaComanda);
                return true;
            }
        }

        public bool delLineaComanda(int idLineaComanda)
        {
            if (Existe(idLineaComanda))
            {
                return colLiniesComanda.Remove(idLineaComanda);
            }
            else
            {
                return false;
            }
        }
        public bool delLineaComanda(LineaComanda objLineaComanda)
        {
            if (Existe(objLineaComanda.IdLineaComanda))
            {
                return colLiniesComanda.Remove(objLineaComanda.IdLineaComanda);
            }
            else
            {
                return false;
            }
        }

        public bool Existe(int idLineaComanda)
        {
            if (colLiniesComanda.ContainsKey(idLineaComanda))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        public LineaComanda getLineaComanda(int idLineaComanda)
        {
            if (Existe(idLineaComanda))
            {
                return colLiniesComanda[idLineaComanda];
            }
            else
            {
                return null;
            }
        }

        public Dictionary<int, LineaComanda> getDiccionario()
        {
            return colLiniesComanda;
        }
    }
}
