﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WcfRestaurant.Objectes
{
    public class Treballador
    {
        private string idTreballador;
        private string nom;
        private string cognom1;
        private string cognom2;
        private string contrasenya;
        private Rol idRol;
        private Boolean habilitat;

        public string IdTreballador
        {
            get { return this.idTreballador; }
            set { this.idTreballador = value; }
        }

        public string Nom
        {
            get { return this.nom; }
            set { this.nom = value; }
        }

        public string Cognom1
        {
            get { return this.cognom1; }
            set { this.cognom1 = value; }
        }

        public string Cognom2
        {
            get { return this.cognom2; }
            set { this.cognom2 = value; }
        }
        public string Contrasenya
        {
            get { return this.contrasenya; }
            set { this.contrasenya = value; }
        }

        public Rol IdRol
        {
            get { return this.idRol; }
            set { this.idRol = value; }
        }

        public Boolean Habilitat
        {
            get { return this.habilitat; }
            set { this.habilitat = value; }
        }
    }

    public class Treballadors
    {
        private Dictionary<string, Treballador> colTreballadors;

        public Treballadors()
        {
            this.colTreballadors = new Dictionary<string, Treballador>();
        }

        public bool addTreballador(Treballador objTreballador)
        {
            if (Existe(objTreballador.IdTreballador))
            {
                return false;
            }
            else
            {
                colTreballadors.Add(objTreballador.IdTreballador, objTreballador);
                return true;
            }
        }

        public bool delTreballador(string idTreballador)
        {
            if (Existe(idTreballador))
            {
                return colTreballadors.Remove(idTreballador);
            }
            else
            {
                return false;
            }
        }
        public bool delTreballador(Treballador objTreballador)
        {
            if (Existe(objTreballador.IdTreballador))
            {
                return colTreballadors.Remove(objTreballador.IdTreballador);
            }
            else
            {
                return false;
            }
        }

        public bool Existe(string idTreballador)
        {
            if (colTreballadors.ContainsKey(idTreballador))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        public Treballador getTreballador(string idTreballador)
        {
            if (Existe(idTreballador))
            {
                return colTreballadors[idTreballador];
            }
            else
            {
                return null;
            }
        }

        public Dictionary<string, Treballador> getDiccionario()
        {
            return colTreballadors;
        }
    }
}
