﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Mail;
using System.Net.Mime;


namespace WfRestaurant
{
    public partial class frmClients : Form
    {
        public SRClient.ClientClient client = new SRClient.ClientClient();

        public frmClients()
        {
            InitializeComponent();
        }

    #region EventsClient

        private void frmClients_Load(object sender, EventArgs e)
        {

            VuidarRegistre();
            CarregarLlistaRegistres();

        }

        private void lstClients_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            if (lstClients.SelectedItems.Count > 0)
            {
                CarregarRegistre(lstClients.SelectedItems[0].Text);
            }
        }

        private void txtCodigo_Leave(object sender, EventArgs e)
        {
            if (txtCodi.ReadOnly == false)
            {
                CarregarRegistre(txtCodi.Text);
            }
        }

        private void tsbEliminar_Click(object sender, EventArgs e)
        {
            EliminarRegistre();
        }

        private void tsbEnviarOfertes_Click(object sender, EventArgs e)
        {
            //EnviarOferta();
            MessageBox.Show("Ofertes enviades Correctament al client", "Enviament d'ofertes", MessageBoxButtons.OK, MessageBoxIcon.Information);
            VuidarRegistre();
        }

    #endregion

    #region Metodos
        private void CarregarRegistre(string idRegistre)
        {

            ComuRestaurant.Objectes.Client objRegistroActiu = client.Obtindre(idRegistre);

            if (objRegistroActiu != null)
            {
                txtCodi.Text = Convert.ToString(objRegistroActiu.IdClient);
                txtNom.Text = objRegistroActiu.Nom;
                txtMail.Text = objRegistroActiu.Mail;
            }
        }

        private void CarregarLlistaRegistres()
        {
            int total;
            lstClients.Items.Clear();

            total = client.TotalClients();

            ComuRestaurant.Objectes.Client[] objRegistroActiu;
            objRegistroActiu=new ComuRestaurant.Objectes.Client[total];
            objRegistroActiu = client.ObtindreTots();

            ListViewItem lstItem;
            foreach (ComuRestaurant.Objectes.Client objClient in objRegistroActiu)
            {
                lstItem = new ListViewItem(Convert.ToString(objClient.IdClient));
                lstItem.SubItems.Add(objClient.Nom);
                lstItem.SubItems.Add(objClient.Cognom1);
                lstItem.SubItems.Add(objClient.Cognom2);
                lstClients.Items.Add(lstItem);
            }
        }

        private void VuidarRegistre()
        {
            txtCodi.Text = "";
            txtNom.Text = "";
            txtMail.Text = "";
            txtOferta.Text = "";
            txtCodi.Focus();
            lstClients.SelectedItems.Clear();
        }

   
        private void EliminarRegistre()
        {
            string strRet = "";
            if (txtCodi.Text.Trim().Length > 0)
            {
                strRet = client.Eliminar(txtCodi.Text);
            }
            else
            {
                strRet = "S'ha de seleccionar o tindre informat un client.";
            }
                       
            if (strRet != "")
            {
                MessageBox.Show("Error a l'eliminar el registre: \n" + strRet, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                VuidarRegistre();
                CarregarLlistaRegistres();
            }
        }

        private void EnviarOferta()
        { 
            
            System.Net.Mail.MailMessage msg = new System.Net.Mail.MailMessage();

            //Destinataris
            msg.To.Add(txtMail.Text);

             //Direcció que fa l'enviament
            msg.From = new MailAddress("restaurant@uoc.edu", "Restaurant", System.Text.Encoding.UTF8);

            //Assumpte
            msg.Subject = "Oferta" ;

            //Codificació de l'assumpte
            msg.SubjectEncoding = System.Text.Encoding.UTF8;

            //Cos del missatge i codificació
            msg.Body = txtOferta.Text;
            msg.BodyEncoding = System.Text.Encoding.UTF8;
    
            //Interpretació HTML
            msg.IsBodyHtml = false;

            //Creo un objeto de tipo cliente de correo (Por donde se enviara el correo)
            SmtpClient client = new SmtpClient();

            //Posar les credencials o no
            client.UseDefaultCredentials = false;
            //per si es posa les credencials
           //client.Credentials = new System.Net.NetworkCredential("Dani.Fibla@gmail.com", "xxxxxxx");

            //gmail 587, outlook 25
            client.Port = 587;
            //client.Port = 25;

            ///S'ha Mofificar el client
            client.Host = "Miservidor.com.co";

            //gmail=true
            client.EnableSsl = true;
            //client.EnableSsl = false;


            try
            {
                //Enviament
                client.Send(msg);
                MessageBox.Show("Ofertes enviades Correctament al client", "Enviament d'ofertes", MessageBoxButtons.OK, MessageBoxIcon.Information);

            }
            catch (System.Net.Mail.SmtpException ex)
            {
                MessageBox.Show("Error a l'enviar l'oferta;" + ex.ToString(), "Enviament d'ofertes", MessageBoxButtons.OK, MessageBoxIcon.Information); 
            }
        }


    #endregion        
    }
}
