﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WfRestaurant
{
    public partial class frmComanda : Form
    {
        public SRComandes.ComandesClient client = new SRComandes.ComandesClient();
        
        public frmComanda()
        {
            InitializeComponent();
        }

        #region EventsTreballadors

        private void frmComanda_Load(object sender, EventArgs e)
        {
            VuidarRegistre();
            CarregarLlistaRegistres();
            tm1.Enabled = true;
        }

        private void tsbEliminar_Click(object sender, EventArgs e)
        {

            EliminarRegistre();
        }

        private void tsbEliminarLinea_Click(object sender, EventArgs e)
        {

            if (txtCodi.Text.Trim().Length > 0)
            {
                string[] sLinea;
                char caracter = Convert.ToChar("-");
                sLinea = lstComandes.SelectedItems[0].Text.Split(caracter);
                EliminarLinea(sLinea[1]);
            }
        }
        
        private void tsbServida_Click(object sender, EventArgs e)
        {
            if (txtCodi.Text.Trim().Length > 0)
            {
                string[] sLinea;
                char caracter = Convert.ToChar("-");
                sLinea = lstComandes.SelectedItems[0].Text.Split(caracter);
                Servir(sLinea[1]);
            }
        }

        private void lstComandes_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (lstComandes.SelectedItems.Count > 0)
            {
                string[] sComanda;
                char caracter = Convert.ToChar("-");
                sComanda = lstComandes.SelectedItems[0].Text.Split(caracter);
                CarregarRegistre(sComanda[0]);
            }
        }

        private void tm1_Tick(object sender, EventArgs e)
        {
            CarregarLlistaRegistres();
        }

        #endregion

        #region Metodos

        private void CarregarRegistre(string idRegistre)
        {

            ComuRestaurant.Objectes.Comanda objRegistroActiu = client.Obtindre(idRegistre);

            if (objRegistroActiu != null)
            {
                txtCodi.Text =Convert.ToString(objRegistroActiu.IdComanda);
                txtTaula.Text = Convert.ToString(objRegistroActiu.Taula);
                txtComensals.Text = Convert.ToString(objRegistroActiu.Comensals);
                txtCodi.ReadOnly = true;
                txtTaula.ReadOnly = true;
                txtComensals.ReadOnly = true;
            }
        }

        private void CarregarLlistaRegistres()
        {
            int total;
            lstComandes.Items.Clear();


            total = client.TotalComandes();

            ComuRestaurant.Objectes.Comanda[] objRegistroActiu;
            objRegistroActiu = new ComuRestaurant.Objectes.Comanda[total];
            objRegistroActiu = client.ObtindreTots();

            //ComuRestaurant.Objectes.Treballador objRegistro = client.Obtindre("Dani");

            ListViewItem lstItem;
            foreach (ComuRestaurant.Objectes.Comanda objComanda in objRegistroActiu)
            {
                string taula =Convert.ToString(objComanda.Taula);
                string comanda =Convert.ToString(objComanda.IdComanda);
                foreach (ComuRestaurant.Objectes.LineaComanda objLinea in objComanda.LiniesComandes)
                {
                    lstItem = new ListViewItem(comanda + "-" + Convert.ToString(objLinea.IdLineaComanda));
                    lstItem.SubItems.Add(taula);
                    lstItem.SubItems.Add(objLinea.Plat1.NomCAT);
                    lstItem.SubItems.Add(objLinea.Plat2.NomCAT);
                    lstItem.SubItems.Add(objLinea.Postre.NomCAT);
                    lstComandes.Items.Add(lstItem);
                }
            }
        }

        private void VuidarRegistre()
        {
            txtCodi.Text = "";
            txtTaula.Text = "";
            txtComensals.Text = "";
            txtCodi.ReadOnly = false;
            txtCodi.Focus();
            lstComandes.SelectedItems.Clear();
        }

        private void EliminarRegistre()
        {
            string strRet = "";
            if (txtCodi.Text.Trim().Length > 0)
            {
                DialogResult bEsborrar = MessageBox.Show("Estas segur de voler esborrar aquesta comanda", "Elimiar Cpmanda", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                if (bEsborrar == DialogResult.Yes)
                {
                    strRet = client.Eliminar(txtCodi.Text);
                }
            }
            else
            {
                strRet = "S'ha de seleccionar o tindre informat una comanda.";
            }

            if (strRet != "")
            {
                MessageBox.Show("Error a l'eliminar el registre: \n" + strRet, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                VuidarRegistre();
                CarregarLlistaRegistres();
            }
        }

        private void EliminarLinea(string IdLinea)
        {
            string strRet = "";
            if (lstComandes.SelectedItems != null)
            {
                DialogResult bEsborrar = MessageBox.Show("Estas segur de voler esborrar aquesta línea de la comanda", "Elimiar Línea Cpmanda", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                if (bEsborrar == DialogResult.Yes)
                {
                    strRet = client.EliminarLineaComanda(IdLinea);
                }
            }
            else
            {
                strRet = "S'ha de seleccionar una linea de comanda.";
            }

            if (strRet != "")
            {
                MessageBox.Show("Error a l'eliminar el registre: \n" + strRet, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
          
                CarregarLlistaRegistres();
            }
        }

        private void Servir(string IdLinea)
        {
            string strRet =  client.LineaServida(IdLinea);
            if (strRet != "")
            {
                MessageBox.Show("Error a l'actualitzar el registre: \n" + strRet, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {

                CarregarLlistaRegistres();
            }
        }


        #endregion
    }
}
