﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WfRestaurant
{
    public partial class frmMenu : Form
    {

        public SRMenus.MenuClient client = new SRMenus.MenuClient();
        public SRTipusPlats.TipusPlatsClient clientTipus = new SRTipusPlats.TipusPlatsClient();
        public SRPlat.PlatsClient clientPlat = new SRPlat.PlatsClient();

        public frmMenu()
        {
            InitializeComponent();
        }

        #region EventsPlats

        private void frmMenu_Load(object sender, EventArgs e)
        {
            VuidarRegistre();
            CarregarLlistaRegistres();
            CarregarCombos();
        }

        private void lstMenu_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (lstMenu.SelectedItems.Count > 0)
            {
                CarregarRegistre(lstMenu.SelectedItems[0].Text);
            }
        }

        private void tsbNou_Click(object sender, EventArgs e)
        {
            VuidarRegistre();
        }

        private void tsbGuardar_Click(object sender, EventArgs e)
        {
            DesarRegistre();
        }

        private void tsbCancelar_Click(object sender, EventArgs e)
        {
            CarregarRegistre(txtCodi.Text);
        }

        

        private void txtCodi_Leave(object sender, EventArgs e)
        {
            if (txtCodi.ReadOnly == false)
            {
                CarregarRegistre(txtCodi.Text);
            }
        }


        private void tsbEliminar_Click(object sender, EventArgs e)
        {
            EliminarRegistre();
        }

        private void cmbTipus1_SelectedIndexChanged(object sender, EventArgs e)
        {
            string[] sTipus;
            char caracter = Convert.ToChar("-");
            sTipus = cmbTipus1.Text.Split(caracter);

            CarregarComboPlats(1, Convert.ToInt32(sTipus[0]));
        }

        private void cmbTipus2_SelectedIndexChanged(object sender, EventArgs e)
        {
            string[] sTipus;
            char caracter = Convert.ToChar("-");
            sTipus = cmbTipus2.Text.Split(caracter);
            
            CarregarComboPlats(2,Convert.ToInt32(sTipus[0]));
        }

        private void cmbPostres_SelectedIndexChanged(object sender, EventArgs e)
        {
            string[] sTipus;
            char caracter = Convert.ToChar("-");
            sTipus = cmbPostres.Text.Split(caracter);

            CarregarComboPlats(3, Convert.ToInt32(sTipus[0]));
        }

        #endregion

        #region Metodos
        private void CarregarRegistre(string idRegistre)
        {

            ComuRestaurant.Objectes.Menu objRegistroActiu = client.Obtindre(idRegistre);

            if (objRegistroActiu != null)
            {
                txtCodi.Text = Convert.ToString(objRegistroActiu.IdMenu);
                txtNom.Text = objRegistroActiu.Nom;
                chkBeguda.Checked = objRegistroActiu.Beguda;
                chkIVA.Checked = objRegistroActiu.IVA;
                cmbTipus1.Text = objRegistroActiu.Plat1.Tipus.IdTipus + "-" + objRegistroActiu.Plat1.Tipus.Nom;
                cmbTipus2.Text = objRegistroActiu.Plat2.Tipus.IdTipus + "-" + objRegistroActiu.Plat2.Tipus.Nom;
                cmbPostres.Text = objRegistroActiu.Postre.Tipus.IdTipus + "-" + objRegistroActiu.Postre.Tipus.Nom;
                cmbPlat.Text = objRegistroActiu.Plat1.NomCAT;
                cmbPlat2.Text = objRegistroActiu.Plat2.NomCAT;
                cmbPostre.Text = objRegistroActiu.Postre.NomCAT;
                txtPreu.Text = Convert.ToString(objRegistroActiu.Preu);
                txtComensals.Text=Convert.ToString(objRegistroActiu.Comensals);
                txtCodi.ReadOnly = true;
            }
        }

        private void CarregarLlistaRegistres()
        {
            int total;
            lstMenu.Items.Clear();


            total = client.TotalMenus();

            ComuRestaurant.Objectes.Menu[] objRegistroActiu;
            objRegistroActiu = new ComuRestaurant.Objectes.Menu[total];
            objRegistroActiu = client.ObtindreTots();

            ListViewItem lstItem;
            foreach (ComuRestaurant.Objectes.Menu objMenu in objRegistroActiu)
            {
                lstItem = new ListViewItem(Convert.ToString(objMenu.IdMenu));
                lstItem.SubItems.Add(objMenu.Nom);
                lstItem.SubItems.Add(objMenu.Plat1.NomCAT);
                lstItem.SubItems.Add(objMenu.Plat2.NomCAT);
                lstItem.SubItems.Add(objMenu.Postre.NomCAT);
                lstItem.SubItems.Add(Convert.ToString(objMenu.Beguda));
                lstItem.SubItems.Add(Convert.ToString(objMenu.IVA));
                lstItem.SubItems.Add(Convert.ToString(objMenu.Preu)+" €");
                lstItem.SubItems.Add(Convert.ToString(objMenu.Comensals));
                lstMenu.Items.Add(lstItem);
            }
        }

        private void CarregarCombos()
        {
            int total;
            int i=0;
            cmbTipus1.Items.Clear();
            cmbTipus2.Items.Clear();
            cmbPostres.Items.Clear();

            total = clientTipus.TotalTipusPlats();

            ComuRestaurant.Objectes.TipusPlat[] objRegistroActiu;
            objRegistroActiu = new ComuRestaurant.Objectes.TipusPlat[total];
            objRegistroActiu = clientTipus.ObtindreTots();

            foreach (ComuRestaurant.Objectes.TipusPlat objTipus in objRegistroActiu)
            {
                cmbTipus1.Items.Insert(i,objTipus.IdTipus + "-" + objTipus.Nom);
                cmbTipus2.Items.Insert(i,objTipus.IdTipus + "-" + objTipus.Nom);
                cmbPostres.Items.Insert(i, objTipus.IdTipus + "-" + objTipus.Nom);
                i=i+1;
            }


        }


        private void VuidarRegistre()
        {
            txtCodi.Text = "";
            txtNom.Text = "";
            txtComensals.Text = "";
            txtPreu.Text = "";
            txtComensals.Text = "";
            chkBeguda.Checked = false;
            chkIVA.Checked = false;
            if (cmbTipus1.Items.Count>0) cmbTipus1.SelectedIndex = 0;
            if (cmbTipus2.Items.Count > 0) cmbTipus2.SelectedIndex = 0;
            if (cmbPostres.Items.Count > 0) cmbPostres.SelectedIndex = 0;
            cmbPlat.Text = "";
            cmbPlat2.Text = "";
            cmbPostre.Text = "";
            txtCodi.ReadOnly = true;
            txtNom.Focus();
            lstMenu.SelectedItems.Clear();
        }

        private void DesarRegistre()
        {
            string strRet = "";

            if (txtNom.Text.Trim().Length == 0) strRet = "El camp Nom es obligatori";
            if (cmbPlat.Text.Trim().Length == 0) strRet = "El combo del primer plat es obligatori";
            if (cmbPlat2.Text.Trim().Length == 0) strRet = "El combo del segon plat es obligatori";
            if (cmbPostres.Text.Trim().Length == 0) strRet = "El combo del postre es obligatori";
            if (txtPreu.Text.Trim().Length == 0) strRet = "El camp Preu es obligatori";

            if (strRet == "")
            {
                ComuRestaurant.Objectes.Menu objRegistreActiu = new ComuRestaurant.Objectes.Menu();

                if (txtCodi.Text.Trim().Length == 0) txtCodi.Text = "0";
                objRegistreActiu.IdMenu =Convert.ToInt32(txtCodi.Text);
                objRegistreActiu.Nom = txtNom.Text;
                ComuRestaurant.Objectes.Plat plat = new ComuRestaurant.Objectes.Plat();
                ComuRestaurant.Objectes.Plat plat1 = new ComuRestaurant.Objectes.Plat();
                ComuRestaurant.Objectes.Plat plat2 = new ComuRestaurant.Objectes.Plat();
                plat.NomCAT = cmbPlat.Text;
                objRegistreActiu.Plat1 = plat;
                plat1.NomCAT = cmbPlat2.Text;
                objRegistreActiu.Plat2 = plat1;
                plat2.NomCAT = cmbPostre.Text;
                objRegistreActiu.Postre = plat2;
                objRegistreActiu.Preu =txtPreu.Text;
                objRegistreActiu.Comensals = Convert.ToInt32(txtComensals.Text);
                objRegistreActiu.IVA = chkIVA.Checked;
                objRegistreActiu.Beguda = chkBeguda.Checked;


                strRet = client.Desar(objRegistreActiu);
                if (strRet != "") MessageBox.Show("Error al guardar el registre: \n" + strRet, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtCodi.ReadOnly = true;
                CarregarLlistaRegistres();
            }
            else
            {
                MessageBox.Show(strRet, "Validació valors introduits", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void EliminarRegistre()
        {
            string strRet = "";
            if (txtCodi.Text.Trim().Length > 0)
            {
                strRet = client.Eliminar(txtCodi.Text);
            }
            else
            {
                strRet = "S'ha de seleccionar o tindre informat un plat.";
            }

            if (strRet != "")
            {
                MessageBox.Show("Error a l'eliminar el registre: \n" + strRet, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                VuidarRegistre();
                CarregarLlistaRegistres();
            }
        }

        private void CarregarComboPlats(int Combo,int Tipus)
        {
            int total;
            int i = 0;

            if (Combo == 1)
            {
                cmbPlat.Items.Clear();
            }
            else if (Combo == 2)
            {
                cmbPlat2.Items.Clear();
            }
            else
            {
                cmbPostre.Items.Clear();
            }
           
            total = clientPlat.TotalPlats();

            ComuRestaurant.Objectes.Plat[] objRegistroActiu;
            objRegistroActiu = new ComuRestaurant.Objectes.Plat[total];
            objRegistroActiu = clientPlat.ObtindreTotsPerTipus(Tipus);

            foreach (ComuRestaurant.Objectes.Plat objTipus in objRegistroActiu)
            {
                if (Combo == 1)
                {
                    cmbPlat.Items.Insert(i, objTipus.NomCAT);
                }
                else if (Combo == 2)
                {
                    cmbPlat2.Items.Insert(i, objTipus.NomCAT);
                }
                else
                {
                    cmbPostre.Items.Insert(i, objTipus.NomCAT);
                }
                i = i + 1;
            }
        }

        #endregion  
   }
}
