﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WfRestaurant
{
    public partial class frmPlats : Form
    {
        public SRPlat.PlatsClient client = new SRPlat.PlatsClient();
        public SRTipusPlats.TipusPlatsClient clientTipus = new SRTipusPlats.TipusPlatsClient();

        public frmPlats()
        {
            InitializeComponent();
        }

        #region EventsPlats
        private void frmPlats_Load(object sender, EventArgs e)
        {
            VuidarRegistre();
            CarregarLlistaRegistres();
            CarregarCombo();
        }


        private void lstPlats_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (lstPlats.SelectedItems.Count > 0)
            {
                CarregarRegistre(lstPlats.SelectedItems[0].Text);
            }
        }

        private void tsbNou_Click(object sender, EventArgs e)
        {
            VuidarRegistre();
        }


        private void tsbDesar_Click(object sender, EventArgs e)
        {
            DesarRegistre();
        }

        private void tsbCancelar_Click(object sender, EventArgs e)
        {
            CarregarRegistre(txtCodi.Text);
        }

        private void txtCodigo_Leave(object sender, EventArgs e)
        {
            if (txtCodi.ReadOnly == false)
            {
                CarregarRegistre(txtCodi.Text);
            }
        }


        private void tsbEliminar_Click(object sender, EventArgs e)
        {
            EliminarRegistre();
        }

        #endregion

        #region Metodos
        private void CarregarRegistre(string idRegistre)
        {

            ComuRestaurant.Objectes.Plat objRegistroActiu = client.Obtindre(idRegistre);

            if (objRegistroActiu != null)
            {
                txtCodi.Text = Convert.ToString(objRegistroActiu.IdPlat);
                txtNom.Text = objRegistroActiu.NomCAT;
                txtNom2.Text = objRegistroActiu.NomESP;
                txtNom3.Text = objRegistroActiu.NomENG;
                cmbTipus.Text = objRegistroActiu.Tipus.Nom;
                txtPreu.Text = Convert.ToString(objRegistroActiu.Preu);
                txtComensals.Text=Convert.ToString(objRegistroActiu.Comensals);
                txtCodi.ReadOnly = true;
            }
        }

        private void CarregarLlistaRegistres()
        {
            int total;
            lstPlats.Items.Clear();


            total = client.TotalPlats();

            ComuRestaurant.Objectes.Plat[] objRegistroActiu;
            objRegistroActiu = new ComuRestaurant.Objectes.Plat[total];
            objRegistroActiu = client.ObtindreTots();

            //ComuRestaurant.Objectes.Treballador objRegistro = client.Obtindre("Dani");

            ListViewItem lstItem;
            foreach (ComuRestaurant.Objectes.Plat objPlat in objRegistroActiu)
            {
                lstItem = new ListViewItem(Convert.ToString(objPlat.IdPlat));
                lstItem.SubItems.Add(objPlat.NomCAT);
                lstItem.SubItems.Add(objPlat.NomESP);
                lstItem.SubItems.Add(objPlat.NomENG);                
                lstItem.SubItems.Add(Convert.ToString(objPlat.Preu)+' '+'€');
                lstItem.SubItems.Add(Convert.ToString(objPlat.Comensals));
                lstItem.SubItems.Add(objPlat.Tipus.Nom);
                lstPlats.Items.Add(lstItem);
            }
        }

        private void CarregarCombo()
        {
            int total;
            int i=0;
            cmbTipus.Items.Clear();

            total = clientTipus.TotalTipusPlats();

            ComuRestaurant.Objectes.TipusPlat[] objRegistroActiu;
            objRegistroActiu = new ComuRestaurant.Objectes.TipusPlat[total];
            objRegistroActiu = clientTipus.ObtindreTots();

            foreach (ComuRestaurant.Objectes.TipusPlat objTipus in objRegistroActiu)
            {
                cmbTipus.Items.Insert(i, objTipus.Nom);
                i=i+1;
            }

        }


        private void VuidarRegistre()
        {
            txtCodi.Text = "";
            txtNom.Text = "";
            txtNom2.Text = "";
            txtNom3.Text = "";
            txtComensals.Text = "";
            txtPreu.Text = "";
            if (cmbTipus.Items.Count>0) cmbTipus.SelectedIndex = 0; 
            txtCodi.ReadOnly = true;
            txtNom.Focus();
            lstPlats.SelectedItems.Clear();
        }

        private void DesarRegistre()
        {
            string strRet = "";

            if (txtNom.Text.Trim().Length == 0) strRet = "El camp Nom es obligatori";
            if (cmbTipus.Text.Trim().Length == 0) strRet = "El combo Tipus de Plat es obligatori";


            if (strRet == "")
            {
                ComuRestaurant.Objectes.Plat objRegistreActiu = new ComuRestaurant.Objectes.Plat();

                if (txtCodi.Text.Trim().Length == 0) txtCodi.Text = "0";
                objRegistreActiu.IdPlat =Convert.ToInt32(txtCodi.Text);
                objRegistreActiu.NomCAT = txtNom.Text;
                objRegistreActiu.NomESP = txtNom2.Text;
                objRegistreActiu.NomENG = txtNom3.Text;
                ComuRestaurant.Objectes.TipusPlat objTipus = new ComuRestaurant.Objectes.TipusPlat();
                objTipus.IdTipus = cmbTipus.SelectedIndex + 1;
                objTipus.Nom = cmbTipus.Text;
                objRegistreActiu.Tipus = objTipus;
                objRegistreActiu.Preu = txtPreu.Text;
                objRegistreActiu.Comensals = Convert.ToInt32(txtComensals.Text);

                strRet = client.Desar(objRegistreActiu);
                if (strRet != "") MessageBox.Show("Error al guardar el registre: \n" + strRet, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtCodi.ReadOnly = true;
                CarregarLlistaRegistres();
            }
            else
            {
                MessageBox.Show(strRet, "Validació valors introduits", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void EliminarRegistre()
        {
            string strRet = "";
            if (txtCodi.Text.Trim().Length > 0)
            {
                strRet = client.Eliminar(txtCodi.Text);
            }
            else
            {
                strRet = "S'ha de seleccionar o tindre informat un plat.";
            }

            if (strRet != "")
            {
                MessageBox.Show("Error a l'eliminar el registre: \n" + strRet, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                VuidarRegistre();
                CarregarLlistaRegistres();
            }
        }

        #endregion              
    }
}
