﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WfRestaurant
{
    public partial class frmTipusPlats : Form
    {
        public SRTipusPlats.TipusPlatsClient client = new SRTipusPlats.TipusPlatsClient();
        
        public frmTipusPlats()
        {
            InitializeComponent();
        }

    #region EventosUsuarios
        private void frmTipusPlats_Load(object sender, EventArgs e)
        {
            VuidarRegistre();
            CarregarLlistaRegistres();
        }

        private void lstTreballadors_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            if (lstTipusPlat.SelectedItems.Count > 0)
            {
                CarregarRegistre(lstTipusPlat.SelectedItems[0].Text);
            }
        }

        private void tsbNou_Click(object sender, EventArgs e)
        {
            VuidarRegistre();
        }

        private void tsbGuardar_Click(object sender, EventArgs e)
        {
            DesarRegistre();
        }

        private void tsbCancelar_Click(object sender, EventArgs e)
        {
            CarregarRegistre(txtCodi.Text);
        }

        private void txtCodigo_Leave(object sender, EventArgs e)
        {
            if (txtCodi.ReadOnly == false)
            {
                CarregarRegistre(txtCodi.Text);
            }
        }

        private void tsbEliminar_Click(object sender, EventArgs e)
        {
            EliminarRegistre();
        }

    #endregion

    #region Metodos
        private void CarregarRegistre(string idRegistre)
        {

            ComuRestaurant.Objectes.TipusPlat objRegistroActiu = client.Obtindre(idRegistre);

            if (objRegistroActiu != null)
            {
                txtCodi.Text = Convert.ToString(objRegistroActiu.IdTipus);
                txtNom.Text = objRegistroActiu.Nom;
            
                txtCodi.ReadOnly = true;
            }
        }

        private void CarregarLlistaRegistres()
        {
            int total;
            lstTipusPlat.Items.Clear();

            total = client.TotalTipusPlats();

            ComuRestaurant.Objectes.TipusPlat[] objRegistroActiu;
            objRegistroActiu=new ComuRestaurant.Objectes.TipusPlat[total];
            objRegistroActiu = client.ObtindreTots();

            ListViewItem lstItem;
            foreach (ComuRestaurant.Objectes.TipusPlat objTreballador in objRegistroActiu)
            {
                lstItem = new ListViewItem(Convert.ToString(objTreballador.IdTipus));
                lstItem.SubItems.Add(objTreballador.Nom);
                lstTipusPlat.Items.Add(lstItem);
            }
        }

        private void VuidarRegistre()
        {
            txtCodi.Text = "";
            txtNom.Text = "";
            txtCodi.ReadOnly = true;
            txtNom.Focus();
            lstTipusPlat.SelectedItems.Clear();
        }

        private void DesarRegistre()
        {
            string strRet = "";

            if (txtNom.Text.Trim().Length == 0) strRet = "El camp Nom es obligatori";
           

            if (strRet == "")
            {
                ComuRestaurant.Objectes.TipusPlat objRegistreActiu = new ComuRestaurant.Objectes.TipusPlat();
                if (txtCodi.Text.Trim().Length == 0)  {txtCodi.Text="0";}
                objRegistreActiu.IdTipus = Convert.ToInt32(txtCodi.Text);
                objRegistreActiu.Nom = txtNom.Text;
                strRet = client.Desar(objRegistreActiu);
                if (strRet != "") MessageBox.Show("Error al guardar el registre: \n" + strRet, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtCodi.ReadOnly = true;
                CarregarLlistaRegistres();
             }
            else
            {
                MessageBox.Show(strRet, "Validació valors introduits", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void EliminarRegistre()
        {
            string strRet = "";
            if (txtCodi.Text.Trim().Length > 0)
            {
                strRet = client.Eliminar(txtCodi.Text);
            }
            else
            {
                strRet = "S'ha de seleccionar o tindre informat un trebalaldor.";
            }
                       
            if (strRet != "")
            {
                MessageBox.Show("Error a l'eliminar el registre: \n" + strRet, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                VuidarRegistre();
                CarregarLlistaRegistres();
            }
        }


    #endregion        
    }
}
