﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WfRestaurant
{
    public partial class frmTreballadors : Form
    {
        public SRTreballador.TreballadorClient client = new SRTreballador.TreballadorClient();
        
        public frmTreballadors()
        {
            InitializeComponent();
        }

    #region EventsTreballadors
        private void frmTreballadors_Load(object sender, EventArgs e)
        {
            VuidarRegistre();
            CarregarLlistaRegistres();
        }

        private void lstTreballadors_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            if (lstTreballadors.SelectedItems.Count > 0)
            {
                CarregarRegistre(lstTreballadors.SelectedItems[0].Text);
            }
        }

        private void tsbNou_Click(object sender, EventArgs e)
        {
            VuidarRegistre();
        }

        private void tsbGuardar_Click(object sender, EventArgs e)
        {
            GuardarRegistre();
        }

        private void tsbCancelar_Click(object sender, EventArgs e)
        {
            CarregarRegistre(txtCodi.Text);
        }

        private void txtCodigo_Leave(object sender, EventArgs e)
        {
            if (txtCodi.ReadOnly == false)
            {
                CarregarRegistre(txtCodi.Text);
            }
        }

        private void tsbEliminar_Click(object sender, EventArgs e)
        {
            EliminarRegistre();
        }

        private void tsbCanviarContrasena_Click(object sender, EventArgs e)
        {
            CanviarContrasenya();
            CarregarLlistaRegistres();
        }
    #endregion

    #region Metodos
        private void CarregarRegistre(string idRegistre)
        {

            ComuRestaurant.Objectes.Treballador objRegistroActiu = client.Obtindre(idRegistre);

            if (objRegistroActiu != null)
            {
                txtCodi.Text = objRegistroActiu.IdTreballador;
                txtNom.Text = objRegistroActiu.Nom;
                txtCognom1.Text = objRegistroActiu.Cognom1;
                txtCognom2.Text = objRegistroActiu.Cognom2;
                cmbRol.SelectedIndex =objRegistroActiu.IdRol.IdRol-1;
                txtCodi.ReadOnly = true;
            }
        }

        private void CarregarLlistaRegistres()
        {
            int total;
            lstTreballadors.Items.Clear();

            total = client.TotalTreballadors();

            ComuRestaurant.Objectes.Treballador[] objRegistroActiu;
            objRegistroActiu=new ComuRestaurant.Objectes.Treballador[total];
            objRegistroActiu = client.ObtindreTots();

            ListViewItem lstItem;
            foreach (ComuRestaurant.Objectes.Treballador objTreballador in objRegistroActiu)
            {
                lstItem = new ListViewItem(objTreballador.IdTreballador);
                lstItem.SubItems.Add(objTreballador.Nom);
                lstItem.SubItems.Add(objTreballador.Cognom1);
                lstItem.SubItems.Add(objTreballador.Cognom2);
                lstItem.SubItems.Add(objTreballador.IdRol.Nombre);
                lstTreballadors.Items.Add(lstItem);
            }
        }

        private void VuidarRegistre()
        {
            txtCodi.Text = "";
            txtNom.Text = "";
            txtCognom1.Text = "";
            txtCognom2.Text = "";
            cmbRol.SelectedIndex = 0;
            txtCodi.ReadOnly = false;
            txtCodi.Focus();
            lstTreballadors.SelectedItems.Clear();
        }

        private void GuardarRegistre()
        {
            string strRet = "";

            if (txtCodi.Text.Trim().Length == 0) strRet = "El camp Codi es obligatori";
            if (txtNom.Text.Trim().Length == 0) strRet = "El camp Nom es obligatori";
            if (cmbRol.Text.Trim().Length == 0) strRet = "El combo Rol es obligatori";
            

            if (strRet == "")
            {
                ComuRestaurant.Objectes.Treballador objRegistreActiu = new ComuRestaurant.Objectes.Treballador();
                objRegistreActiu.IdTreballador = txtCodi.Text;
                objRegistreActiu.Nom = txtNom.Text;
                objRegistreActiu.Cognom1 = txtCognom1.Text;
                objRegistreActiu.Cognom2 = txtCognom2.Text;
                ComuRestaurant.Objectes.Rol objRol = new ComuRestaurant.Objectes.Rol();
                objRol.IdRol = cmbRol.SelectedIndex + 1 ;
                objRegistreActiu.IdRol=objRol;

                strRet = client.Desar(objRegistreActiu);
                if (strRet != "") MessageBox.Show("Error al guardar el registre: \n" + strRet, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtCodi.ReadOnly = true;
                CarregarLlistaRegistres();
             }
            else
            {
                MessageBox.Show(strRet, "Validació valors introduits", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void EliminarRegistre()
        {
            string strRet = "";
            if (txtCodi.Text.Trim().Length > 0)
            {
                strRet = client.Eliminar(txtCodi.Text);
            }
            else
            {
                strRet = "S'ha de seleccionar o tindre informat un trebalaldor.";
            }
                       
            if (strRet != "")
            {
                MessageBox.Show("Error a l'eliminar el registre: \n" + strRet, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                VuidarRegistre();
                CarregarLlistaRegistres();
            }
        }

        private void CanviarContrasenya()
        {
            string strContrasenya = "";
            string strRet = "";

            if (txtCodi.Text.Trim().Length > 0)
            {
                frmInputBox oFrm = new frmInputBox();
                oFrm.SetMensaje("Introdueixi la contrasenya a assignar:");
                oFrm.ShowDialog();
                strContrasenya = oFrm.Resposta;

                if (strContrasenya.Trim().Length > 0)
                {
                    client.AssignarContrasenya(txtCodi.Text, strContrasenya);
                }
                else
                {
                    strRet = "Proces cancel·lat o contrasenya no informada.";
                }
            }
            else
            {
                strRet = "S'ha de seleccionar un treballador.";
            }
            if (strRet != "")
            {
                MessageBox.Show("Error al camviar la contrasenya d'un trebalaldor: \n" + strRet, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                MessageBox.Show("Canvi de contrasenya efectuat correctament", "Informació", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
    #endregion        
  
    }
}
