﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace WpaRestaurant
{
    public partial class Comanda : PhoneApplicationPage
    {
        string taula;
        string comensals;
        int comensalComanda = 1;
        string [] liniesComanda;
        SRMobile.MobileClient client = new SRMobile.MobileClient();

        #region Events

        public Comanda()
        {
            InitializeComponent();
        }

        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            this.taula = NavigationContext.QueryString["taula"];
            this.comensals = NavigationContext.QueryString["comensals"];
            liniesComanda = new string[Convert.ToInt32(comensals)];

            InputScope Teclat = new InputScope();
            InputScopeName ScopeName = new InputScopeName();
            ScopeName.NameValue = InputScopeNameValue.Digits;
            Teclat.Names.Add(ScopeName);
            txtPlat1.InputScope = Teclat;
            txtPlat2.InputScope = Teclat;
            txtPlat3.InputScope = Teclat;
            txtComensal.InputScope = Teclat;
            NetejarCamps();
            Habilitar();
        }

        private void txtPlat1_LostFocus(object sender, RoutedEventArgs e)
        {
            if (txtPlat1.Text != "") VerificarPlat(txtPlat1.Text, "1"); 
        }

        private void txtPlat2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (txtPlat2.Text != "") VerificarPlat(txtPlat2.Text, "2");
        }

        private void txtPlat3_LostFocus(object sender, RoutedEventArgs e)
        {
            if (txtPlat3.Text != "")  VerificarPlat(txtPlat3.Text,"3");
        }

        private void txtComensal_LostFocus(object sender, RoutedEventArgs e)
        {
            
            if (txtComensal.Text != "") {

                comensalComanda = Convert.ToInt32(txtComensal.Text);

                if (comensalComanda > Convert.ToInt32(comensals))
                {
                    MessageBox.Show("Comensal Incorrecte", "Comanda", MessageBoxButton.OK);
                }
                else{
                    string[] sPlat;
                    char caracter = Convert.ToChar("#");
                    sPlat = liniesComanda[comensalComanda-1].Split(caracter);
                    txtPlat1.Text = sPlat[0];
                    tbPlat1.Text = sPlat[1];
                    txtPlat2.Text = sPlat[2];
                    tbPlat2.Text = sPlat[3];
                    txtPlat3.Text = sPlat[4];
                    tbPostres.Text = sPlat[5];
                    txtComensal.Visibility = Visibility.Collapsed;
                }
            }
        }

        private void btnVerificar_Click(object sender, RoutedEventArgs e)
        {
            btnComanda.Visibility = Visibility.Collapsed;
            btnModificar.Visibility = Visibility.Visible;
            txtComensal.Visibility = Visibility.Visible;
            btnVerificar.IsEnabled = false;
            tbcomensal.Text = "Introdueixi el comensal";
            Habilitar();
        }



        private void btnModificar_Click(object sender, RoutedEventArgs e)
        {
            if (txtComensal.Text != ""){
                if (VerificarLineaComanda() == true)
                {
                    DesarLineaComanda();
                    NetejarCamps();
                    Deshabilitar();
                    btnComanda.Visibility = Visibility.Visible;
                    txtComensal.Visibility = Visibility.Collapsed;
                    btnModificar.Visibility = Visibility.Collapsed;
                    tbcomensal.Text = "";
                    btnVerificar.IsEnabled = true;
                }
                else
                {
                    MessageBox.Show("Algun dels plats assignats es incorrecte", "Comanda", MessageBoxButton.OK);
                }
            }
            else{
                MessageBox.Show("Sellección un comensal a modificar", "Comanda", MessageBoxButton.OK);
            }
        }



        private void btnComanda_Click(object sender, RoutedEventArgs e)
        {
            EnviarComanda();
        }

        private void btnSeguent_Click(object sender, RoutedEventArgs e)
        {
            if (VerificarLineaComanda() == true)
            {
                if (comensalComanda == Convert.ToInt32(comensals))
                {
                    DesarLineaComanda();
                    NetejarCamps();
                    Deshabilitar();
                    btnSeguent.Visibility = Visibility.Collapsed;
                    btnVerificar.Visibility = Visibility.Visible;
                    btnComanda.Visibility = Visibility.Visible;
                    tbcomensal.Text = "Comanda Finalitzada";
                }
                else
                {

                    DesarLineaComanda();
                    NetejarCamps();
                    comensalComanda = comensalComanda + 1;
                    tbcomensal.Text = "Comensal " + comensalComanda;
                }
            }
            else
            {
                MessageBox.Show("Algun dels plats assignats es incorrecte", "Comanda", MessageBoxButton.OK);
            }
        }

        #endregion

        #region Metodes

        private void VerificarPlat(string idPlat,string posicioPlat)
        {
           // clientPlat.VerificarPlatCompleted +=new EventHandler<SRPlat.VerificarPlatCompletedEventArgs>(clientPlat_VerificarPlatCompleted);
           // clientPlat.VerificarPlatAsync(idPlat, posicioPlat);
          // client.VerificarPlatCompleted +=new EventHandler<SRPlat.VerificarPlatCompletedEventArgs>(client_VerificarPlatCompleted);
            client.VerificarPlatCompleted +=new EventHandler<SRMobile.VerificarPlatCompletedEventArgs>(client_VerificarPlatCompleted);
            client.VerificarPlatAsync(idPlat, posicioPlat);
        }

        void client_VerificarPlatCompleted(object sender, SRMobile.VerificarPlatCompletedEventArgs e)
        {
            string[] sPlat;
            char caracter = Convert.ToChar("-");
            sPlat = e.Result.Split(caracter);

            if (sPlat[0] == "1") {
                tbPlat1.Text = sPlat[1];
            }
            else if (sPlat[0] == "2") {
                tbPlat2.Text = sPlat[1];
            }
            else if (sPlat[0] == "3") {
                tbPostres.Text = sPlat[1];
            }
        }

        private void EnviarComanda()
        {
            string linies = "";

            foreach (string linia in liniesComanda){
                linies = linies + linia + "-";
            }
            char caracter = Convert.ToChar("-");
            linies = taula + "-" + comensals + "-" + linies;
            linies = linies.TrimEnd(caracter);
            client.DesarComandaCompleted +=new EventHandler<SRMobile.DesarComandaCompletedEventArgs>(client_DesarComandaCompleted);
            client.DesarComandaAsync(linies);
        }

        void client_DesarComandaCompleted(object sender, SRMobile.DesarComandaCompletedEventArgs e)
        {
            if (e.Result != "")
            {
                MessageBox.Show("Error al Desar la Comanda, torni a introduïr es dades", "Comanda", MessageBoxButton.OK);
            }
            else
            {
                MessageBox.Show("Comanda realitzada correctament", "Comanda", MessageBoxButton.OK);
            }
            NavigationService.Navigate(new Uri("/pIniciComanda.xaml", UriKind.Relative));
        }

        private bool VerificarLineaComanda()
        {

            if (tbPlat1.Text == "Plat Inexistent") return false;

            if (tbPlat2.Text == "Plat Inexistent") return false;

            if (tbPostres.Text == "Plat Inexistent") return false;

            if (txtPlat1.Text == "") return false;
            
            if (txtPlat2.Text == "") return false;
            
            if (txtPlat3.Text == "") return false;

            return true;
        
        }

        private void DesarLineaComanda()
        {
            liniesComanda[comensalComanda-1] = txtPlat1.Text + "#" + tbPlat1.Text + "#" + txtPlat2.Text + "#"+ tbPlat2.Text + "#" + txtPlat3.Text + "#" + tbPostres.Text;
        }

        private void NetejarCamps()
        {
            tbPlat1.Text = "";
            tbPlat2.Text = "";
            tbPostres.Text = "";
            txtPlat1.Text = "";
            txtPlat2.Text = "";
            txtPlat3.Text = "";
            txtComensal.Text = "";
        }

        private void Habilitar()
        {
            txtPlat1.IsEnabled = true;
            txtPlat2.IsEnabled = true;
            txtPlat3.IsEnabled = true;
        }

        private void Deshabilitar()
        {
            txtPlat1.IsEnabled = false;
            txtPlat2.IsEnabled = false;
            txtPlat3.IsEnabled = false;
        }

        #endregion
        
    }
}